=== modified file 'bzrlib/commands.py'
--- bzrlib/commands.py	2005-11-09 15:50:22 +0000
+++ bzrlib/commands.py	2005-11-16 04:07:29 +0000
@@ -510,14 +510,18 @@
     return ret or 0
 
 def display_command(func):
+    """Decorator that suppresses pipe/interrupt errors."""
     def ignore_pipe(*args, **kwargs):
         try:
             result = func(*args, **kwargs)
             sys.stdout.flush()
             return result
         except IOError, e:
+            if not hasattr(e, 'errno'):
+                raise
             if e.errno != errno.EPIPE:
                 raise
+            pass
         except KeyboardInterrupt:
             pass
     return ignore_pipe

=== modified file 'bzrlib/selftest/test_command.py'
--- bzrlib/selftest/test_command.py	2005-10-19 19:01:25 +0000
+++ bzrlib/selftest/test_command.py	2005-11-16 04:07:29 +0000
@@ -20,6 +20,7 @@
 
 class TestCommands(TestCase):
     def test_display_command(self):
+        """EPIPE message is selectively suppressed"""
         def pipe_thrower():
             raise IOError(errno.EPIPE, "Bogus pipe error")
         self.assertRaises(IOError, pipe_thrower)

